# PicImageSearch

**Aggregated Image Search Engine for Reverse Image Search**

<a href="https://raw.githubusercontent.com/kitUIN/PicImageSearch/master/LICENSE">
<img
    src="https://img.shields.io/github/license/kitUIN/PicImageSearch"
    alt="license"
/>
</a>
<a href="https://pypi.python.org/pypi/PicImageSearch">
<img src="https://img.shields.io/pypi/v/PicImageSearch" alt="pypi"/>
</a>
<img src="https://img.shields.io/badge/python-3.9+-blue" alt="python"/>
<a href="https://github.com/kitUIN/PicImageSearch/releases">
<img
    src="https://img.shields.io/github/v/release/kitUIN/PicImageSearch"
    alt="release"
/>
</a>
<a href="https://github.com/kitUIN/PicImageSearch/issues">
<img
    src="https://img.shields.io/github/issues/kitUIN/PicImageSearch"
    alt="release"
/>
</a>

## What is PicImageSearch?

PicImageSearch is a powerful Python image search library that integrates multiple mainstream reverse image search engines, providing developers with a unified and concise API interface, making the development of image search functions more convenient.

## Project History

### Project Origin

This project initially originated from my need to develop an image search function on the [OPQ](https://github.com/opq-osc/OPQ) QQ robot platform.  
At that time, I found that the image search service APIs on the market were relatively scattered and implemented in different ways, which brought many inconveniences to development.  
To solve this problem, I developed PicImageSearch, which integrates multiple excellent image search engines into a unified interface, greatly simplifying the development process.

### Project Development

During the development of the project, [Neko Aria](https://github.com/NekoAria) joined the development team after being introduced to the [NoneBot2](https://github.com/nonebot/nonebot2) platform.  
He comprehensively refactored the code, introducing more modern design concepts, significantly improving the maintainability and scalability of the project.  
Currently, the project is mainly maintained by Neko Aria, continuously providing the community with better image search solutions.

## Supported Reverse Image Search Engines

<div class="grid cards" markdown>

- ![AnimeTrace](images/anime-trace.png){ .lg .middle } AnimeTrace

    ---

    以图识番 - 在线 AI 识番引擎 | 日漫识别 | 动漫查询 | 动漫基因库

- ![Ascii2D](images/ascii2d.png){ .lg .middle } Ascii2D

    ---

    二次元画像詳細検索

- ![BaiDu](images/baidu.png){ .lg .middle } BaiDu

    ---

    百度图片

- ![Bing](images/bing.png){ .lg .middle } Bing

    ---

    Bing Images

- ![Copyseeker](images/copyseeker.png){ .lg .middle } Copyseeker

    ---

    The Best Free AI Powered Reverse Image Search Like No Other

- ![E-hentai](images/e-hentai.png){ .lg .middle } E-hentai

    ---

    E-Hentai Galleries

- ![Google](images/google.png){ .lg .middle } Google

    ---

    Google Images

- ![Google Lens](images/google-lens.png){ .lg .middle } Google Lens

    ---

    Google Lens

- ![Iqdb](images/iqdb.png){ .lg .middle } Iqdb

    ---

    Multi-service image search

- ![Lenso](images/lenso.png){ .lg .middle } Lenso

    ---

    Lenso.ai - AI Reverse Image Search

- ![SauceNAO](images/saucenao.png){ .lg .middle } SauceNAO

    ---

    SauceNAO Reverse Image Search

- ![Tineye](images/tineye.png){ .lg .middle } Tineye

    ---

    TinEye Reverse Image Search

- ![TraceMoe](images/tracemoe.png){ .lg .middle } TraceMoe

    ---

    Anime Scene Search Engine

- ![Yandex](images/yandex.png){ .lg .middle } Yandex

    ---

    Yandex Images

</div>

## Contributors to this project

<div class="grid cards" markdown>

- ![Neko Aria](https://github.com/NekoAria.png){ .lg .middle } Neko Aria

    ---

    Project Maintainer

- ![kitUIN](https://github.com/kitUIN.png){ .lg .middle } kitUIN

    ---

    Project Owner

- ![Peloxerat](https://github.com/Peloxerat.png){ .lg .middle } Peloxerat

    ---

    Project Contributor

- ![lleans](https://github.com/lleans.png){ .lg .middle } lleans

    ---

    Project Contributor

- ![chinoll](https://github.com/chinoll.png){ .lg .middle } chinoll

    ---

    Project Contributor

- ![Nachtalb](https://github.com/Nachtalb.png){ .lg .middle } Nachtalb

    ---

    Project Contributor

</div>
