# PicImageSearch

**逆画像検索エンジンの集大成**

<a href="https://raw.githubusercontent.com/kitUIN/PicImageSearch/master/LICENSE">
<img
    src="https://img.shields.io/github/license/kitUIN/PicImageSearch"
    alt="license"
/>
</a>
<a href="https://pypi.python.org/pypi/PicImageSearch">
<img src="https://img.shields.io/pypi/v/PicImageSearch" alt="pypi"/>
</a>
<img src="https://img.shields.io/badge/python-3.9+-blue" alt="python"/>
<a href="https://github.com/kitUIN/PicImageSearch/releases">
<img
    src="https://img.shields.io/github/v/release/kitUIN/PicImageSearch"
    alt="release"
/>
</a>
<a href="https://github.com/kitUIN/PicImageSearch/issues">
<img
    src="https://img.shields.io/github/issues/kitUIN/PicImageSearch"
    alt="release"
/>
</a>

## PicImageSearch とは何ですか？

PicImageSearch は強力な Python 画像検索ライブラリで、複数の主要な画像逆検索エンジンを統合し、開発者に統一かつ簡潔な API インターフェースを提供し、画像検索機能の開発をより便利にします。

## プロジェクトの歴史

### プロジェクトの起源

このプロジェクトは、私が [OPQ](https://github.com/opq-osc/OPQ) QQ ロボットプラットフォームで画像検索機能を開発する必要があったことから始まりました。  
当時、市場に出回っている画像検索サービス API は比較的分散しており、それぞれの実装方法が異なり、開発に多くの不便をもたらしていました。  
この問題を解決するために、私は PicImageSearch を開発し、複数の優れた画像検索エンジンを統一インターフェースに統合し、開発プロセスを大幅に簡素化しました。

### プロジェクトの発展

プロジェクトの発展過程で、[Neko Aria](https://github.com/NekoAria) は [NoneBot2](https://github.com/nonebot/nonebot2) プラットフォームに触れた後、開発チームに参加しました。  
彼はコードを全面的にリファクタリングし、より現代的な設計理念を導入し、プロジェクトの保守性と拡張性を大幅に向上させました。  
現在、プロジェクトは主に Neko Aria によって維持されており、コミュニティにより良い画像検索ソリューションを提供し続けています。

## サポートされている逆画像検索エンジン

<div class="grid cards" markdown>

- ![AnimeTrace](images/anime-trace.png){ .lg .middle } AnimeTrace

    ---

    以图识番 - 在线 AI 识番引擎 | 日漫识别 | 动漫查询 | 动漫基因库

- ![Ascii2D](images/ascii2d.png){ .lg .middle } Ascii2D

    ---

    二次元画像詳細検索

- ![BaiDu](images/baidu.png){ .lg .middle } BaiDu

    ---

    百度图片

- ![Bing](images/bing.png){ .lg .middle } Bing

    ---

    Bing Images

- ![Copyseeker](images/copyseeker.png){ .lg .middle } Copyseeker

    ---

    The Best Free AI Powered Reverse Image Search Like No Other

- ![E-hentai](images/e-hentai.png){ .lg .middle } E-hentai

    ---

    E-Hentai Galleries

- ![Google](images/google.png){ .lg .middle } Google

    ---

    Google Images

- ![Google Lens](images/google-lens.png){ .lg .middle } Google Lens

    ---

    Google Lens

- ![Iqdb](images/iqdb.png){ .lg .middle } Iqdb

    ---

    Multi-service image search

- ![Lenso](images/lenso.png){ .lg .middle } Lenso

    ---

    Lenso.ai - AI Reverse Image Search

- ![SauceNAO](images/saucenao.png){ .lg .middle } SauceNAO

    ---

    SauceNAO Reverse Image Search

- ![Tineye](images/tineye.png){ .lg .middle } Tineye

    ---

    TinEye Reverse Image Search

- ![TraceMoe](images/tracemoe.png){ .lg .middle } TraceMoe

    ---

    Anime Scene Search Engine

- ![Yandex](images/yandex.png){ .lg .middle } Yandex

    ---

    Yandex Images

</div>

## このプロジェクトの貢献者

<div class="grid cards" markdown>

- ![Neko Aria](https://github.com/NekoAria.png){ .lg .middle } Neko Aria

    ---

    プロジェクトのメイン管理者

- ![kitUIN](https://github.com/kitUIN.png){ .lg .middle } kitUIN

    ---

    プロジェクトオーナー

- ![Peloxerat](https://github.com/Peloxerat.png){ .lg .middle } Peloxerat

    ---

    プロジェクト貢献者

- ![lleans](https://github.com/lleans.png){ .lg .middle } lleans

    ---

    プロジェクト貢献者

- ![chinoll](https://github.com/chinoll.png){ .lg .middle } chinoll

    ---

    プロジェクト貢献者

- ![Nachtalb](https://github.com/Nachtalb.png){ .lg .middle } Nachtalb

    ---

    プロジェクト貢献者

</div>
