# PicImageSearch

**Агрегатор Обратного Поиска Изображений**

<a href="https://raw.githubusercontent.com/kitUIN/PicImageSearch/master/LICENSE">
<img
    src="https://img.shields.io/github/license/kitUIN/PicImageSearch"
    alt="license"
/>
</a>
<a href="https://pypi.python.org/pypi/PicImageSearch">
<img src="https://img.shields.io/pypi/v/PicImageSearch" alt="pypi"/>
</a>
<img src="https://img.shields.io/badge/python-3.9+-blue" alt="python"/>
<a href="https://github.com/kitUIN/PicImageSearch/releases">
<img
    src="https://img.shields.io/github/v/release/kitUIN/PicImageSearch"
    alt="release"
/>
</a>
<a href="https://github.com/kitUIN/PicImageSearch/issues">
<img
    src="https://img.shields.io/github/issues/kitUIN/PicImageSearch"
    alt="release"
/>
</a>

## Что такое PicImageSearch?

PicImageSearch — это мощная библиотека Python для поиска изображений, которая интегрирует несколько основных систем обратного поиска изображений, предоставляя разработчикам единый и простой интерфейс API, что делает разработку функций поиска изображений более удобной.

## История проекта

### Происхождение проекта

Этот проект изначально возник из моей потребности разработать функцию поиска изображений на платформе QQ-робота [OPQ](https://github.com/opq-osc/OPQ).  
Тогда я обнаружил, что API сервисов поиска изображений на рынке были неполными и реализованы по-разному, что создавало множество неудобств для разработки.  
Чтобы решить эту проблему, я разработал PicImageSearch, который интегрирует несколько отличных поисковых систем изображений в единый интерфейс, значительно упрощая процесс разработки.

### Развитие проекта

В процессе развития проекта [Neko Aria](https://github.com/NekoAria) присоединился к команде разработчиков после знакомства с платформой [NoneBot2](https://github.com/nonebot/nonebot2).  
Он полностью переработал код, внедрив более современные концепции дизайна, что значительно улучшило поддерживаемость и расширяемость проекта.  
В настоящее время проект в основном поддерживается Neko Aria, продолжая предоставлять сообществу лучшие решения для поиска изображений.

## Поддерживаемые поисковые системы обратного поиска изображений

<div class="grid cards" markdown>

- ![AnimeTrace](images/anime-trace.png){ .lg .middle } AnimeTrace

    ---

    以图识番 - 在线 AI 识番引擎 | 日漫识别 | 动漫查询 | 动漫基因库

- ![Ascii2D](images/ascii2d.png){ .lg .middle } Ascii2D

    ---

    二次元画像詳細検索

- ![BaiDu](images/baidu.png){ .lg .middle } BaiDu

    ---

    百度图片

- ![Bing](images/bing.png){ .lg .middle } Bing

    ---

    Bing Images

- ![Copyseeker](images/copyseeker.png){ .lg .middle } Copyseeker

    ---

    The Best Free AI Powered Reverse Image Search Like No Other

- ![E-hentai](images/e-hentai.png){ .lg .middle } E-hentai

    ---

    E-Hentai Galleries

- ![Google](images/google.png){ .lg .middle } Google

    ---

    Google Images

- ![Google Lens](images/google-lens.png){ .lg .middle } Google Lens

    ---

    Google Lens

- ![Iqdb](images/iqdb.png){ .lg .middle } Iqdb

    ---

    Multi-service image search

- ![Lenso](images/lenso.png){ .lg .middle } Lenso

    ---

    Lenso.ai - AI Reverse Image Search

- ![SauceNAO](images/saucenao.png){ .lg .middle } SauceNAO

    ---

    SauceNAO Reverse Image Search

- ![Tineye](images/tineye.png){ .lg .middle } Tineye

    ---

    TinEye Reverse Image Search

- ![TraceMoe](images/tracemoe.png){ .lg .middle } TraceMoe

    ---

    Anime Scene Search Engine

- ![Yandex](images/yandex.png){ .lg .middle } Yandex

    ---

    Yandex Images

</div>

## Участники этого проекта

<div class="grid cards" markdown>

- ![Neko Aria](https://github.com/NekoAria.png){ .lg .middle } Neko Aria

    ---

    Основной Сопровождающий Проекта

- ![kitUIN](https://github.com/kitUIN.png){ .lg .middle } kitUIN

    ---

    Владелец Проекта

- ![Peloxerat](https://github.com/Peloxerat.png){ .lg .middle } Peloxerat

    ---

    Участник Проекта

- ![lleans](https://github.com/lleans.png){ .lg .middle } lleans

    ---

    Участник Проекта

- ![chinoll](https://github.com/chinoll.png){ .lg .middle } chinoll

    ---

    Участник Проекта

- ![Nachtalb](https://github.com/Nachtalb.png){ .lg .middle } Nachtalb

    ---

    Участник Проекта

</div>
