# PicImageSearch

**聚合识图引擎 用于以图搜源**

<a href="https://raw.githubusercontent.com/kitUIN/PicImageSearch/master/LICENSE">
<img
    src="https://img.shields.io/github/license/kitUIN/PicImageSearch"
    alt="license"
/>
</a>
<a href="https://pypi.python.org/pypi/PicImageSearch">
<img src="https://img.shields.io/pypi/v/PicImageSearch" alt="pypi"/>
</a>
<img src="https://img.shields.io/badge/python-3.9+-blue" alt="python"/>
<a href="https://github.com/kitUIN/PicImageSearch/releases">
<img
    src="https://img.shields.io/github/v/release/kitUIN/PicImageSearch"
    alt="release"
/>
</a>
<a href="https://github.com/kitUIN/PicImageSearch/issues">
<img
    src="https://img.shields.io/github/issues/kitUIN/PicImageSearch"
    alt="release"
/>
</a>

## PicImageSearch 是什么？

PicImageSearch 是一个强大的 Python 图片搜索库，它整合了多个主流的图片逆向搜索引擎，为开发者提供统一且简洁的 API 接口，让图片搜索功能的开发变得更加便捷。

## 项目历程

### 项目起源

本项目最初源于我在 [OPQ](https://github.com/opq-osc/OPQ) QQ 机器人平台开发图片搜索功能时的需求。  
当时发现市面上的图片搜索服务 API 较为零散，各自实现方式不一，给开发带来了诸多不便。  
为了解决这个问题，我开发了 PicImageSearch，将多个优秀的搜图引擎整合到统一的接口中，大大简化了开发流程。

### 项目发展

在项目发展过程中，[Neko Aria](https://github.com/NekoAria) 在接触 [NoneBot2](https://github.com/nonebot/nonebot2) 平台后加入了开发团队。  
他对代码进行了全面的重构，引入了更现代的设计理念，显著提升了项目的可维护性和可扩展性。  
目前，项目由 Neko Aria 主要负责维护，持续为社区提供更好的图片搜索解决方案。

## 支持的识图引擎

<div class="grid cards" markdown>

- ![AnimeTrace](images/anime-trace.png){ .lg .middle } AnimeTrace

    ---

    以图识番 - 在线 AI 识番引擎 | 日漫识别 | 动漫查询 | 动漫基因库

- ![Ascii2D](images/ascii2d.png){ .lg .middle } Ascii2D

    ---

    二次元画像詳細検索

- ![BaiDu](images/baidu.png){ .lg .middle } BaiDu

    ---

    百度图片

- ![Bing](images/bing.png){ .lg .middle } Bing

    ---

    Bing Images

- ![Copyseeker](images/copyseeker.png){ .lg .middle } Copyseeker

    ---

    The Best Free AI Powered Reverse Image Search Like No Other

- ![E-hentai](images/e-hentai.png){ .lg .middle } E-hentai

    ---

    E-Hentai Galleries

- ![Google](images/google.png){ .lg .middle } Google

    ---

    Google Images

- ![Google Lens](images/google-lens.png){ .lg .middle } Google Lens

    ---

    Google Lens

- ![Iqdb](images/iqdb.png){ .lg .middle } Iqdb

    ---

    Multi-service image search

- ![Lenso](images/lenso.png){ .lg .middle } Lenso

    ---

    Lenso.ai - AI Reverse Image Search

- ![SauceNAO](images/saucenao.png){ .lg .middle } SauceNAO

    ---

    SauceNAO Reverse Image Search

- ![Tineye](images/tineye.png){ .lg .middle } Tineye

    ---

    TinEye Reverse Image Search

- ![TraceMoe](images/tracemoe.png){ .lg .middle } TraceMoe

    ---

    Anime Scene Search Engine

- ![Yandex](images/yandex.png){ .lg .middle } Yandex

    ---

    Yandex Images

</div>

## 项目贡献者

<div class="grid cards" markdown>

- ![Neko Aria](https://github.com/NekoAria.png){ .lg .middle } Neko Aria

    ---

    项目维护者

- ![kitUIN](https://github.com/kitUIN.png){ .lg .middle } kitUIN

    ---

    项目创建者

- ![Peloxerat](https://github.com/Peloxerat.png){ .lg .middle } Peloxerat

    ---

    项目贡献者

- ![lleans](https://github.com/lleans.png){ .lg .middle } lleans

    ---

    项目贡献者

- ![chinoll](https://github.com/chinoll.png){ .lg .middle } chinoll

    ---

    项目贡献者

- ![Nachtalb](https://github.com/Nachtalb.png){ .lg .middle } Nachtalb

    ---

    项目贡献者

</div>
